<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\AdjustmentbbmModel;
use App\Http\Models\StgpelniscmmiscrcvintModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class AdjustmentbbmsService extends BaseService
{
	/**
     AdjustmentbbmService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new AdjustmentbbmModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()
			->select([
				"adjustmentbbm.transactionNo",
				"adjustmentbbm.transactionDate",
				"adjustmentbbm.voyageStart",
				"adjustmentbbm.voyageEnd",
				"adjustmentbbm.id",
				"adjustmentbbm.quantity",
				"adjustmentbbm.voyageName"
			]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("adjustmentbbm.kapalId", "=", $auth->kapalId);
		}

		/* $this->model->getQuery()->whereIn('adjustmentbbm.transactionNo', function ($query) use ($auth) {
			$query->select('itemadjustmentbbm.transactionNo')
				->from('itemadjustmentbbm')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itemadjustmentbbm.itemId");
					$join->on("item.kapalId", "=", "adjustmentbbm.kapalId");
				})
				->whereIn("item.type_id", $auth->arrCategory)
				->whereIn("itemadjustmentbbm.locationId", $auth->arrLokasi);
		}); */

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("adjustmentbbm.date_updated", "desc");
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return AdjustmentbbmModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationUserId()->joinRelationLocationId()->getQuery()
			->select([
				"adjustmentbbm.*",
				"locationId.namaLokasi",
				"users.name as userName"
			])
			->where("adjustmentbbm.id", "=", $id)->first();
		return $model;
	}

	public function showByTransactionNo($noTransaction)
	{
		$model = $this->model->joinRelationRequesterId()->joinRelationVoyageKode()->getQuery()
			->select([
				"adjustmentbbm.*",
				"requesterId.jabatan as userJabatan",
				"voyageKode.voyageName"
			])
			->where("adjustmentbbm.transactionNo", "=", $noTransaction)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return AdjustmentbbmModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$transactionBrg = new AdjustmentbbmModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return AdjustmentbbmModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$adjustmentbbm = AdjustmentbbmModel::find($id);
		$adjustmentbbm->fill($input);
		if (!$adjustmentbbm->update()) {
			throw new \Exception();
		}
		return $adjustmentbbm;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}


	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("adjustmentbbm"."transactionNo", 9, 6)) AS "transactionNo"')->where("adjustmentbbm.transactionNo", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->transactionNo + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function getPrepareUpdateStock($input)
	{
		$data = [];
		$data[] = [
			"itemId" 		=> $input["itemId"],
			"kapalId" 		=> $input["kapalId"],
			"lokasiId" 		=> $input["locationId"],
			"jumlah" 		=> $input["quantity"],
			"satuan" 		=> "",
			"status" 		=> 1,
			"type" 			=> 1,
			"lotNumber" 	=> $input["lotNumber"],
			"tglMasuk" 		=> $input["transactionDate"],
			"harga_satuan" 	=> $input["harga_satuan"],

			// ADDITION FOR STOCK HISTORY
			"transaksi"		=> "adjustmentbbm",
			"noTransaksi"	=> $input["refId"],
			"username"		=> $input["username"],
			"periode"		=> $input["transactionDate"]
		];

		return $data;
	}

	public function saveStaging($input)
	{
		$data =  [
			"transaction_number"			=> $input["transactionNo"],
			"organization_id"				=> $input["kapalId"],
			"subinventory_code"				=> $input["namaLokasi"],
			"transfer_date"					=> date("Y-m-d H:i:s"),
			"voyage_call"					=> $input["voyageKode"],
			"type_misc"						=> "RCV",
			"source_code"					=> "BEGBAL",
			"process_flag"					=> 1,
			"transaction_mode"				=> 3,
			"lock_flag" 					=> 2,


			"inventory_item_id"				=> $input["itemId"],
			"item_segment1"					=> $input["namaItem"],
			"transaction_quantity"			=> $input["quantity"],
			"transaction_uom"				=> $input["UOM"],
			"transaction_date"				=> $input["transactionDate"],
			"attribute2"					=> $input["lotNumber"],
			"transaction_source_type_id"	=> 13,
			"transaction_action_id"			=> 27,

			"attribute14"                   => $input["userJabatan"],
			"total_line"					=> 1

		];

		$stagingModel = new StgpelniscmmiscrcvintModel();
		$stagingModel->fill($data);
		if (!$stagingModel->save()) {
			throw new \Exception();
		}
	}

	public function getAdjusmentItem($itemID, $voyageID = "", $voyageFrom, $voyageTo)
	{
		$model = (new AdjustmentbbmModel())->getQuery()
			->where("adjustmentbbm.itemId", "=", $itemID)
			->where("adjustmentbbm.transactionDate", ">=", $voyageFrom)
			->where("adjustmentbbm.transactionDate", "<=", $voyageTo);

		if (!empty($voyageID)) {
			$model->where("adjustmentbbm.voyageKode", "=", $voyageID);
		}

		return $model->get();
	}

	public function getSumItemVoyage($itemID, $voyageID, $voyageFrom, $voyageTo)
	{
		$totalQty = 0;
		$model = $this->getAdjusmentItem($itemID, $voyageID, $voyageFrom, $voyageTo);
		foreach ($model as $row) {
			$totalQty += $row->quantity;
		}
		return $totalQty;
	}
	public function getSumItemBulan($itemID, $tahun, $bulan)
	{
		$from = $tahun . "-" . $bulan . "-01";
		$to = date("Y-m-t", strtotime($from));
		$totalQty = 0;
		$model = $this->getAdjusmentItem($itemID, "", $from, $to);
		foreach ($model as $row) {
			$totalQty += $row->quantity;
		}
		return $totalQty;
	}
}
